;********************************************
;@   p[MOSFEThCo[H@@@      |
;@@@@@@@@@vOVer1.1@   |
;@@ @@@@@@@@@@@@yJK-FFz     |
;                  MOTOR_CTL.asm            |
;     EINTOSC(4MHz,GP4:I/O)                |
;     E/MCLR:Internal,WDTE:Diable          |
;     EPWRTE,BODEN:Enable                  |
;     Ȇ̐ݒ:Disable                |
;********************************************
	list		P=PIC12F629
	__config H'31c4'
	include  <P12F629.inc>

;@@ϐ`
old	equ		0x20
new	equ		0x21

;@@vO{
	org		0x00
c_start		goto	h_start

	org		0x10
h_start	
	bcf		STATUS,RP0   		;Page0
	clrf	GPIO
	movlw	07h	     	;Set GP<2:0> 
	movwf	CMCON	     ;  to digit I/O
	bsf		STATUS,RP0   	;Page1
;//	clrf		ANSEL	     ;Digital I/O  P12F675
	movlw	0x0c	     	;XXOO IIOO
	movwf	TRISIO
	bcf		STATUS,RP0   ;Page0

	clrf	old
	clrf	new

;@͑҂iԕω̌o)
inp_lop	
	movf	GPIO,W
	andlw	0x0c	     ;GP3,2̒o
	movwf	new
	xorwf	old,W
	btfsc	STATUS,Z   ;skip Vf[^
	goto	inp_lop

;  V̓f[^̑Ҕ
	movf	new,W
	movwf	old

;   [^t[
;        mP-FET<='H'(off),N-FET<='L'(off)] 
	bsf		GPIO,0	;P-FET <= 'H'(OFF)
	nop
	bcf		GPIO,1	;N-FET <= 'L'(OFF)
                        ; [^t[
	nop

;   F/B(GP2)̔
	btfsc	new,2	;GP2(F/B)̔
	goto	next_1
	nop
	btfss	new,3	;GP3(PWM)̔
	goto	next_2
	bsf		GPIO,1	;N-FET <= 'H'(ON)
	goto	inp_lop	;͑҂

next_1	
	btfsc	new,3	;GP3(PWM)̔
	bsf		GPIO,1  ;N-FET <= 'H'(ON)
	goto	inp_lop	;͑҂
next_2
	bcf		GPIO,0  ;P-FET <= 'L'(ON)
	goto	inp_lop	;͑҂

	end
